import os 
os.system('pip install bayes_opt')
import time
import moxing as mox
import pandas as pd
from statistics import mean
import operator
import math
import numpy as np
mox.file.copy_parallel('s3://bucket-010/xiongbo/dataset/', '/cache/data/')
from RNN import *

start_time = time.time()

oa_lhd = pd.read_csv('/cache/data/9_3_3.csv', header=0).values.astype(float)

search_range = [[0.0005, 0.01], [0.0005, 0.01], [64, 1024]]


for i in range(9):
    mox.file.append('s3://bucket-010/xiongbo/results/rnn_search_space_9_3_3.log', str(search_range)+'\n')
    for row in oa_lhd:
        config = []
        for j in range(0, len(search_range)):
            lower, upper = search_range[j][0], search_range[j][1]
            config.append(lower + row[j]*(upper-lower))
            
        line = rnn_run(config[0], config[1], 3, int(config[2]))
        mox.file.append('s3://bucket-010/xiongbo/results/rnn_lhd_9_3_'+str(i)+'.log', line+'\n')
    
    mox.file.copy_parallel('s3://bucket-010/xiongbo/results/', '/cache/data/')
    df = pd.read_csv('/cache/data/rnn_lhd_9_3_'+str(i)+'.log', header=None)
    df.columns = ['lr', 'lam', 'n_l', 'n_n', 'losses', 'time']
    
    line = str(sorted(df['losses'],  reverse=True)[0:10])
    mox.file.append('s3://bucket-010/xiongbo/results/top_10_rnn_9_3'+str(i)+'.log', line+'\n')

    colunm_range = {'lr':search_range[0] , 'lam': search_range[1],'n_n': search_range[2]}

    mean_analysis = []
    acc_dict = {}
    best_level = []
    level_num = {'lr': 3, 'lam': 3,'n_n': 3}
    var_dict = {}
    col_level_acc = {}
    acc_list = []

    for col_name in ['lr', 'lam', 'n_n']:
        levels_dict = {}
        level_var_dict = {}
        for row_num in range(0, len(df)):
            acc = df['losses'].iloc[row_num]
            level = df[col_name].iloc[row_num]

            r = colunm_range[col_name][1] - colunm_range[col_name][0]
            v = level - colunm_range[col_name][0]

            key = math.floor((v/r)*level_num[col_name])

            if levels_dict.get(key)==None:
                levels_dict[key] = []
            levels_dict[key].append(acc)
            acc_list.append(acc)

        for key in levels_dict:
            level_var_dict[key] = np.var(levels_dict[key])
            levels_dict[key] = mean(levels_dict[key])    

        acc_dict[col_name] = levels_dict
        print(levels_dict)
        acc_dict[col_name] = max(levels_dict.items(), key=operator.itemgetter(1))[0]
        var_dict[col_name] = level_var_dict

    std = np.std(acc_list)


    print('best level',acc_dict)
    var_dict

    best_level_var = {}

    for key, level in acc_dict.items():
        best_level_var[key] = var_dict[key][level]
    #     print(key, var_dict[key][level])

    var_sum = 0
    for k, v in best_level_var.items():
        var_sum = var_sum + v

    for k, v in best_level_var.items():
        print(k, acc_dict[k], "std:",std,"level var:", best_level_var[k], "level ratio:",  best_level_var[k]/var_sum)

    print('col, level, low, mid, upper')
    search_range = []
    for key in colunm_range:
        r = colunm_range[key][1] - colunm_range[key][0]
        low = colunm_range[key][0]+ (r/level_num[key])*acc_dict[key]
        up = low+ (r/level_num[key])
        mean_value = low+(up-low)/2
        search_range.append([low, up])
        print(key, acc_dict[key], low, mean_value, up)

print("Running time of the optimization is ", time.time() - start_time)
